#ifdef USE_DUMP
#include <gl/image.h>
#include <gl/gl.h>

/* internal prototyping */
void cpacktorgb ( long *, 
		 unsigned short *, unsigned short *, unsigned short *, int);

/* dump screen image to a file 'dumped_screen', 
   given the left-bottom cordinate (x,y), and size
   information xsize, and ysize
 */
screendump(x, y, xsize, ysize)
int xsize,ysize;		/* size of the image */
int x,y;			/* lower left corner */
{
    unsigned long *dumparray;	/* storage for image */
    unsigned short *rbuf;	/* R value for a row */
    unsigned short *gbuf;	/* G value for a row */
    unsigned short *bbuf;	/* B value for a row */
    
    IMAGE *oimage;
    
    /* 1. memory allocation */
    dumparray = (unsigned long *) malloc ((xsize+1)*(ysize+1) * 
					  sizeof ( unsigned long));
    rbuf = (unsigned short *) malloc ( (xsize+1) * sizeof ( unsigned short ));
    gbuf = (unsigned short *) malloc ( (xsize+1) * sizeof ( unsigned short ));
    bbuf = (unsigned short *) malloc ( (xsize+1) * sizeof ( unsigned short ));

    if ( dumparray == NULL || rbuf == NULL || gbuf == NULL || bbuf == NULL )
    {
	fprintf(stderr, "Not enough memory for dumping the image.\n");
	exit (-1);
    }
    
    /* 2. read in the image from the proper source */
    readsource(SRC_FRONT);
    lrectread(x,y,x+xsize,y+ysize,dumparray);

    /* 3. open an image file in SGI image format */
    oimage = iopen("dumped_screen","w",RLE(1),3,xsize+1,ysize+1,3);

    /* 4. process read-in image row by row */
    for(y=0;y<ysize;y++) {
	cpacktorgb( (dumparray+y*(xsize+1)),rbuf,gbuf,bbuf,xsize+1);
	putrow(oimage,rbuf,y,0);
	putrow(oimage,gbuf,y,1);
	putrow(oimage,bbuf,y,2);
    }
    iclose(oimage);

    /* 5. free up the memory allocated */
    free(dumparray);
    free(rbuf);
    free(gbuf);
    free(bbuf);
}

/* pack rgb into a long for image output */
void
cpacktorgb(l,r,g,b,n)
long *l;
unsigned short *r,*g,*b;
int n;
{
	long val;

	while(n--) {
		val = *l++;
		*r++ = val & 0xff;
		val >>= 8;
		*g++ = val & 0xff;
		val >>= 8;
		*b++ = val & 0xff;
	}
}
 
#endif
